# Sequence type

class pyasn1.type.univ.Sequence(componentType=NamedTypes(), tagSet=tagSet(), subtypeSpec=ConstraintsIntersection())

  Create Sequence schema or value object.

  Sequence class is based on `ConstructedAsn1Type`, its objects are mutable and duck-type Python `dict` objects.

  Keyword Arguments:

    - componentType (`NamedType`) – Object holding named ASN.1 types allowed within this collection

    - tagSet (`TagSet`) – Object representing non-default ASN.1 tag(s)

    - subtypeSpec (`ConstraintsIntersection`) – Object representing non-default ASN.1 subtype constraint(s). Constraints verification for Sequence type can only occur on explicit .isInconsistent call.

  Examples

      class Description(Sequence):  #  Set is similar
          '''
          ASN.1 specification:

          Description ::= SEQUENCE {
              surname    IA5String,
              first-name IA5String OPTIONAL,
              age        INTEGER DEFAULT 40
          }
          '''
          componentType = NamedTypes(
              NamedType('surname', IA5String()),
              OptionalNamedType('first-name', IA5String()),
              DefaultedNamedType('age', Integer(40))
          )

      descr = Description()
      descr['surname'] = 'Smith'
      descr['first-name'] = 'John'

  Note

  The Sequence type models a collection of named ASN.1 components. Ordering of the components is preserved upon de/serialisation.

  clone(componentType=NamedTypes(), tagSet=tagSet(), subtypeSpec=ConstraintsIntersection())

    Create a modified version of Sequence schema object.

    The clone() method accepts the same set arguments as Sequence class takes on instantiation except that all arguments of the clone() method are optional.

    Whatever arguments are supplied, they are used to create a copy of self taking precedence over the ones used to instantiate self.

    Possible values of self are never copied over thus clone() can only create a new schema object.

    Returns:

      new instance of Sequence type/value

    Note

    Due to the mutable nature of the Sequence object, even if no arguments are supplied, a new Sequence object will be created and returned.

  subtype(componentType=NamedTypes(), implicitTag=Tag(), explicitTag=Tag(), subtypeSpec=ConstraintsIntersection())

    Create a specialization of Sequence schema object.

    The subtype() method accepts the same set arguments as Sequence class takes on instantiation except that all parameters of the subtype() method are optional.

    With the exception of the arguments described below, the rest of supplied arguments they are used to create a copy of self taking precedence over the ones used to instantiate self.

    The following arguments to subtype() create a ASN.1 subtype out of Sequence type.

    Other Parameters:

      - implicitTag (`Tag`) – Implicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - explicitTag (`Tag`) – Explicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - subtypeSpec (`ConstraintsIntersection`) – Add ASN.1 constraints object to one of the self’s, then use the result as new object’s ASN.1 constraints.

    Returns:

      new instance of Sequence type/value

    Note

    Due to the mutable nature of the Sequence object, even if no arguments are supplied, a new Sequence object will be created and returned.

  tagSet = <TagSet object, tags 0:32:16>

    Set (on class, not on instance) or return a `TagSet` object representing ASN.1 tag(s) associated with Sequence type.

  subtypeSpec = <ConstraintsIntersection object>

    Set (on class, not on instance) or return a `ConstraintsIntersection` object imposing constraints on Sequence type initialization values.

  componentType = <NamedTypes object, types >

    Default collection of ASN.1 types of component (e.g. `NamedType`) object imposing size constraint on Sequence objects

  property isValue

    Indicate that Sequence object represents ASN.1 value.

    If isValue is `False` then this object represents just ASN.1 schema.

    If isValue is `True` then, in addition to its ASN.1 schema features, this object can also be used like a Python built-in object (e.g. `int`, `str`, `dict` etc.).

    Returns:

      `bool` – `False` if object represents just ASN.1 schema. `True` if object represents ASN.1 schema and can be used as a normal value.

    Note

    There is an important distinction between PyASN1 schema and value objects. The PyASN1 schema objects can only participate in ASN.1 schema-related operations (e.g. defining or testing the structure of the data). Most obvious uses of ASN.1 schema is to guide serialisation codecs whilst encoding/decoding serialised ASN.1 contents.

    The PyASN1 value objects can additionally participate in many operations involving regular Python objects (e.g. arithmetic, comprehension etc).

    It is sufficient for Sequence objects to have all non-optional and non-defaulted components being value objects to be considered as a value objects as a whole. In other words, even having one or more optional components not turned into value objects, Sequence object is still considered as a value object. Defaulted components are normally value objects by default.

  isSameTypeWith(other, matchTags=True, matchConstraints=True)

    Examine Sequence type for equality with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters:

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns:

      `bool` – `True` if other is Sequence type, `False` otherwise.

  isSuperTypeOf(other, matchTags=True, matchConstraints=True)

    Examine Sequence type for subtype relationship with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters:

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns:

      `bool` – `True` if other is a subtype of Sequence type, `False` otherwise.

  property effectiveTagSet

    For Sequence type is equivalent to tagSet

  property tagMap

    Return a `TagMap` object mapping ASN.1 tags to ASN.1 objects within callee object.

  getComponentByPosition(idx, default=<NoValue object>, instantiate=True)

    Returns Sequence type component by index.

    Equivalent to Python sequence subscription operation (e.g. []).

    Parameters:

      idx (`int`) – Component index (zero-based). Must either refer to an existing component or (if componentType is set) new ASN.1 schema object gets instantiated.

    Keyword Arguments:

      - default (`object`) – If set and requested component is a schema object, return the default object instead of the requested component.

      - instantiate (`bool`) – If `True` (default), inner component will be automatically instantiated. If `False` either existing component or the `NoValue` object will be returned.

    Returns:

      `PyAsn1Item` – a PyASN1 object

    Examples

        # can also be Set
        class MySequence(Sequence):
            componentType = NamedTypes(
                NamedType('id', OctetString())
            )

        s = MySequence()

        # returns component #0 with `.isValue` property False
        s.getComponentByPosition(0)

        # returns None
        s.getComponentByPosition(0, default=None)

        s.clear()

        # returns noValue
        s.getComponentByPosition(0, instantiate=False)

        # sets component #0 to OctetString() ASN.1 schema
        # object and returns it
        s.getComponentByPosition(0, instantiate=True)

        # sets component #0 to ASN.1 value object
        s.setComponentByPosition(0, 'ABCD')

        # returns OctetString('ABCD') value object
        s.getComponentByPosition(0, instantiate=False)

        s.clear()

        # returns noValue
        s.getComponentByPosition(0, instantiate=False)

  setComponentByPosition(idx, value=<NoValue object>, verifyConstraints=True, matchTags=True, matchConstraints=True)

    Assign Sequence type component by position.

    Equivalent to Python sequence item assignment operation (e.g. []).

    Parameters:

      idx (`int`) – Component index (zero-based). Must either refer to existing component (if componentType is set) or to N+1 component otherwise. In the latter case a new component of given ASN.1 type gets instantiated and appended to Sequence sequence.

    Keyword Arguments:

      - value (`object` or `PyAsn1Item` derivative) – A Python value to initialize Sequence component with (if componentType is set) or ASN.1 value object to assign to Sequence component. If value is not given, schema object will be set as a component.

      - verifyConstraints (`bool`) – If `False`, skip constraints validation

      - matchTags (`bool`) – If `False`, skip component tags matching

      - matchConstraints (`bool`) – If `False`, skip component constraints matching

    Returns:

      self

  getComponentByName(name, default=<NoValue object>, instantiate=True)

    Returns Sequence type component by name.

    Equivalent to Python `dict` subscription operation (e.g. []).

    Parameters:

      name (`str`) – Sequence type component name

    Keyword Arguments:

      - default (`object`) – If set and requested component is a schema object, return the default object instead of the requested component.

      - instantiate (`bool`) – If `True` (default), inner component will be automatically instantiated. If `False` either existing component or the `NoValue` object will be returned.

    Returns:

      `PyAsn1Item` – Instantiate Sequence component type or return existing component value

  setComponentByName(name, value=<NoValue object>, verifyConstraints=True, matchTags=True, matchConstraints=True)

    Assign Sequence type component by name.

    Equivalent to Python `dict` item assignment operation (e.g. []).

    Parameters:

      name (`str`) – Sequence type component name

    Keyword Arguments:

      - value (`object` or `PyAsn1Item` derivative) – A Python value to initialize Sequence component with (if componentType is set) or ASN.1 value object to assign to Sequence component. If value is not given, schema object will be set as a component.

      - verifyConstraints (`bool`) – If `False`, skip constraints validation

      - matchTags (`bool`) – If `False`, skip component tags matching

      - matchConstraints (`bool`) – If `False`, skip component constraints matching

    Returns:

      self

  clear()

    Remove all components and become an empty Sequence value object.

    Has the same effect on Sequence object as it does on `dict` built-in.

  reset()

    Remove all components and become a Sequence schema object.

    See `isValue()` property for more information on the distinction between value and schema objects.

  property isInconsistent

    Run necessary checks to ensure Sequence object consistency.

    Default action is to verify Sequence object against constraints imposed by subtypeSpec.

    Raises:

      PyAsn1tError –